# This file is to log temperatures in een SQL database, with date-time stamp.


# First the import of files
import RPi.GPIO as GPIO
import os
import MySQLdb
import time
import datetime
time.sleep(20)

# Then the initialisation of the GPIO
GPIO.setwarnings(False)	
GPIO.setmode(GPIO.BOARD) #By this you are saying you want to use the connector pins as reference
GPIO.setup(11, GPIO.OUT)    # Pin 11 of the connector is used and... (pin# is used, but it is not the GPIO port#!!!)
GPIO.setup(12, GPIO.OUT)    # Pin 12 of the connector is used in this example 

# main program starts here
from datetime import datetime
last_minute=str(datetime.now().minute)

while 1: 
		time.sleep(30)
	# From here temperatures  writing in the textfile and read and convert to float.
		os.system("sudo modprobe w1-gpio")
		os.system("sudo modprobe w1-therm")
		# this wrote data from the sensors into file "/sys/bus/w1/devices/10-000802ddf70a/w1_slave" and "/sys/bus/w1/devices/10-000802de0426/w1_slave"
		# The numbers 10-000802xxxx are the serial numbers of the sensors; It is used as a directory name as well.

		# Open the file of the FIRST sensor & Read all of the text in the file, then Close the file once the text has been read.
		tfile = open("/sys/bus/w1/devices/10-000802ddf70a/w1_slave")
		text = tfile.read()
		tfile.close()
		# Split the text with new lines (\n) and select the second line.
		secondline = text.split("\n")[1]
		# Split the line into words, referring to the spaces, and select the 10th word (counting from 0).
		temperaturedata = secondline.split(" ")[9]
		# The first two characters are "t=", so get rid of those and convert the temperature from a string to a number.
		temperature1 = float(temperaturedata[2:])
		# Put the decimal point in the right place.
		temperature1 = temperature1 / 1000

		# Open the file of the SECOND sensor & Read all of the text in the file, then Close the file once the text has been read.
		tfile = open("/sys/bus/w1/devices/10-000802de0426/w1_slave")
		text = tfile.read()
		tfile.close()
		# Split the text with new lines (\n) and select the second line.
		secondline = text.split("\n")[1]
		# Split the line into words, referring to the spaces, and select the 10th word (counting from 0).
		temperaturedata = secondline.split(" ")[9]
		# The first two characters are "t=", so get rid of those and convert the temperature from a string to a number.
		temperature2 = float(temperaturedata[2:])
		# Put the decimal point in the right place.
		temperature2 = temperature2 / 1000



	# from here get the time and make the string to write the temperatures in the right fields in the database.
		from datetime import datetime
		write_hour=str(datetime.now().hour)
		if write_hour == "0" : write_hour = "24"
		write_hour_temp1="UPDATE modus SET temp1uur"+write_hour+" = %s "
		write_hour_temp2="UPDATE modus SET temp2uur"+write_hour+" = %s "

	# from here database write and read table modus.
		# Open database connection
		db = MySQLdb.connect("localhost","root","xxxxxx","solarair" )

		# prepare a cursor object using cursor() method
		cursor = db.cursor()

		cursor.execute("UPDATE modus SET temperature1 = %s ",temperature1)
		cursor.execute("UPDATE modus SET temperature2 = %s ",temperature2)
		cursor.execute(write_hour_temp1,temperature1)
		cursor.execute(write_hour_temp2,temperature2)
		db.commit()

		sql = "SELECT * FROM modus" 
		# Execute the SQL command
		cursor.execute(sql)

		# Fetch a single row using fetchone() method.
		data = cursor.fetchone()
		print "-----------------------------------Test programma!!!!"
		print "|", data[0], " ~ ", data[1], " ~ ", data[2], "|"
		print "| The hour is now: ", write_hour, "|"
		print "-----------------------------------"
		


	# Vanaf hier de uitgang zetten volgens wat er in de database stond. 
		datastring=str(data)
		if data[0] =="cooling":
			if float(data[2])<= 23: 
				#below 23 DegC
				GPIO.output(11,GPIO.HIGH)
				GPIO.output(12,GPIO.HIGH)
				print 'Output pin#11 and 12 is set HIGH because it starts to cooldown'
				os.system ("cp %s %s" % ("/var/www/html/fan_on.gif", "/var/www/html/fan.gif"))
				fan_stat=1
			else :
				GPIO.output(11,GPIO.LOW)
				GPIO.output(12,GPIO.LOW)
				print 'Output pin#11 and 12 is set low because temperature too high to cool'
				os.system ("cp %s %s" % ("/var/www/html/fan_off.gif", "/var/www/html/fan.gif"))
				fan_stat=0
		if data[0] =="heating":
			if float(data[2])>= 25: #starts heating at 25 DegC!!
				GPIO.output(11,GPIO.HIGH)
				GPIO.output(12,GPIO.HIGH)
				print 'Output pin#11 and 12 is set HIGH because it starts to heat'
				os.system ("cp %s %s" % ("/var/www/html/fan_on.gif", "/var/www/html/fan.gif"))
				fan_stat=1
			else :
				GPIO.output(11,GPIO.LOW)
				GPIO.output(12,GPIO.LOW)
				print 'Output pin#11 and 12 is set low because temperature too low for heating'
				os.system ("cp %s %s" % ("/var/www/html/fan_off.gif", "/var/www/html/fan.gif"))
				fan_stat=0

			
		if data[0] =="manual_off":
			GPIO.output(11,GPIO.LOW)
			GPIO.output(12,GPIO.LOW)
			print 'Output pin#12 is set low, fan turned off'
			os.system ("cp %s %s" % ("/var/www/html/fan_off.gif", "/var/www/html/fan.gif"))
			fan_stat=0
		if data[0] =="manual_on":
			GPIO.output(11,GPIO.HIGH)
			GPIO.output(12,GPIO.HIGH)
			print 'Output pin#11 and 12 is set high, fan turned on'
			os.system ("cp %s %s" % ("/var/www/html/fan_on.gif", "/var/www/html/fan.gif"))
			fan_stat=1


		print "______________________________________________ next cycle..."
		

	# from here database read modus from solarair and write table solarair_log.!!!!!!!!!!!!!!!!!!!!!
		current_minute=str(datetime.now().minute)
		print 'De minuut is nu:',current_minute
		if last_minute!=current_minute:
			print 'Lijn in de logging wordt geschreven'
			last_minute=current_minute
			cursor.execute("SELECT mode FROM modus")
			data = cursor.fetchone()[0]
			cursor.execute("INSERT INTO solarair_log (mode, temperature1, temperature2, fan_stat) VALUES (%s,%s,%s,%s) ",(data, temperature1, temperature2, fan_stat))
			db.commit()
	# Tot hier (hierboven) dit stukje voor de logging!!!!
		


		# disconnect from database
		db.close()


		#break

